package cat.binary.capturavideo;

import java.io.IOException;
import android.annotation.SuppressLint;
import android.app.Activity;
import android.content.Context;
import android.content.pm.PackageManager;
import android.graphics.Color;
import android.hardware.Camera;
import android.hardware.Camera.CameraInfo;
import android.media.CamcorderProfile;
import android.media.MediaRecorder;
import android.os.Bundle;
import android.view.View;
import android.view.WindowManager;
import android.widget.Button;
import android.widget.LinearLayout;
import android.widget.Toast;

public class VideoCaptura extends Activity 
{

	// Definir les variables generals de la classe
	//*******************************************************
	private Camera mCamera;						// Definir un objecte tipus Camera
	private PrevisualitzacioCam mPreview;		// Definir un objecte previsualitzacio
	private MediaRecorder gravadoraMultimedia;	// Definir un objecte MediaRecorder
	private LinearLayout cameraPreview;			// Definir el objecte Layout 
	private Button botoCanvi;					// Definir el objecte boto
	private boolean cameraFrontal = false;		// Definir variable camera Frontal	
	boolean EstaGravant = false;				// Definir variable proces gravacio
	
	
	// Definir la funcio onCreate de l'Activity
	//********************************************
	@Override
	public void onCreate(Bundle savedInstanceState) 
	{
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_video_captura);
		
		// Dir-li que no pot activar el protector i/o desactivar 
		// la pantalla si fa una estona que no ho fem servir
		getWindow().addFlags(WindowManager.LayoutParams.FLAG_KEEP_SCREEN_ON);
		
		// Definir el color de fons de la activitat
		getWindow().getDecorView().setBackgroundColor(Color.BLACK);
		
		// Associar el objecte layout on s'ha de visualitzar la imatge
		// de la camera
		cameraPreview = (LinearLayout) findViewById(R.id.zona_preview);
		
		// Associar el objecte layout del boto amb la varible
		botoCanvi = (Button) findViewById(R.id.botoCanvi);
		
		// Definir el objecte de la classe PrevisualitzacioCam
		// Passar-li el context i el objecte de Camera per inicialitzar
		mPreview = new PrevisualitzacioCam(this, mCamera);
		
		// Afegir dins del objecte del Layout la vista de previsualitzaci
		// de la camera.
		cameraPreview.addView(mPreview);
	}

	//**********************************************************************
	//**********************************************************************
	// Funcions dels events clic del dos botos
	//**********************************************************************
	//**********************************************************************

	// Funcio del clic de boto de canvi entre la camera frontal i del darrera
	//*************************************************************************
	public void clicCanvi(View v)
	{
		// Noms podem canviar de camera si no estem gravant
		if (EstaGravant==false) 
		{
			// Contar quantes cameres tenim
			int camerasNumber = Camera.getNumberOfCameras();
			
			// Noms podem canviar de camera si tenim ms de una
			if (camerasNumber > 1) 
			{
				// Allibera la camera actual
				alliberarCamera();
				// Seleccionar la nova camera
				seleccionarCamera();
			} 
			else 
			{
				Toast toast = Toast.makeText(this, "Noms tens una camera!!", Toast.LENGTH_LONG);
				toast.show();
			}
		}

	}

	// Funcio clic del boto d'iniciar la gravacio
	//*****************************************************
	public void clicIniciar(View v)
	{
		// Si ja estic gravant, parar la gravacio (stop)
		if (EstaGravant == true) 
		{
			// Parar la gravacio
			gravadoraMultimedia.stop();
			
			// Alliberar el objecte de gravacio
			alliberarGravadoraMultimedia();
			
			// Mostrar un missatge de finalitzaci del video
			Toast.makeText(this, "Video gravat!", Toast.LENGTH_LONG).show();
			
			// Canviar el flag per saber que ja no gravem
			EstaGravant = false;
		} 
		else 
		{
			// Si no esta preparada la gravadora multimedia
			if (prepararGravadoraMultimedia() == false) 
			{
				// Mostrar missatge i finalitzar
				Toast.makeText(this, "Error en el medi de gravacio!\n - Fi -", Toast.LENGTH_LONG).show();
				finish();
			}
		
			// Enviar una tasca a la cua en segon pla per comenar a fer
			// la gravaci
			runOnUiThread(new Runnable() 
			{
				// Definir la funci run de la tasca que volem executar
				public void run() 
				{
					try 
					{
						// Iniciar la gravacio
						gravadoraMultimedia.start();
					} 
					catch (final Exception ex) 
					{
						// Error al iniciar la tasca de gravacio
					}
				}
			});

			// Definir el flag que esta en curs la gravacio
			EstaGravant = true;
		}
		
	}

	//*******************************************************
	//*******************************************************
	// Funcionar generals de l'aplicacio
	//*******************************************************
	//*******************************************************
	
	
	// Funcio per buscar si tenim una camera frontal installada
	//***************************************************************
	@SuppressLint("NewApi") private int buscarCameraFrontal() 
	{
		// Variables per definir el ID (identificador) de la camera
		int cameraId = -1;
		
		// Buscar quantes cameres tenim installades
		int numberOfCameras = Camera.getNumberOfCameras();
		
		// Fer un bucle per buscar totes les cameres
		for (int i = 0; i < numberOfCameras; i++) 
		{
			// Definir una objecte per llegir la informaci de la camera
			CameraInfo info = new CameraInfo();
			
			// Llegir la informaci de la camera 1,2,3 .....
			Camera.getCameraInfo(i, info);
			
			// Es la camera frontal?
			if (info.facing == CameraInfo.CAMERA_FACING_FRONT) 
			{
				// Guardar el numero de camera, i activar el flag
				cameraId = i;
				cameraFrontal = true;
				break;
			}
		}
		
		// Retornar el numero de camera
		return cameraId;
	}

	// Funcio per buscar si tenim una camera al darrera installada
	//***************************************************************
	@SuppressLint("NewApi") private int buscarCameraDarrera() 
	{
		// Variables per definir el ID (identificador) de la camera
		int cameraId = -1;

		// Buscar quantes cameres tenim installades
		int numberOfCameras = Camera.getNumberOfCameras();

		// Fer un bucle per buscar totes les cameres
		for (int i = 0; i < numberOfCameras; i++) 
		{
			// Definir una objecte per llegir la informaci de la camera
			CameraInfo info = new CameraInfo();
			
			// Llegir la informaci de la camera 1,2,3 .....
			Camera.getCameraInfo(i, info);
			
			// Es la camera del darrera?
			if (info.facing == CameraInfo.CAMERA_FACING_BACK) 
			{
				// Guardar el numero de camera, i desactivar el flag
				cameraId = i;
				cameraFrontal = false;
				break;
			}
		}
		
		// Retornar el ID de la camera
		return cameraId;
	}



	// Funcio per seleccionar la camera, sempre i quant tinguem ms d'una
	//*********************************************************************
	public void seleccionarCamera() 
	{
		int cameraId = -1;
		
		// Si tenim activada la camera frontal
		if (cameraFrontal == false) 
		{
			// Buscar el codi de la camera del darrera
			cameraId = buscarCameraFrontal();
		}
		else
		{
			cameraId = buscarCameraDarrera();
		}
			
		// Si el codi es ms gran o igual de zero voldr dir que tenim 
		// camera frontal o del darrera
		if (cameraId >= 0) 
		{
			// Obrir la camera amb el ID
			mCamera = Camera.open(cameraId);
				
			// Fer un refresh de la previsualitzacio
			mPreview.refrescarCamera(mCamera);
		}
 
	}

	// Funcio per saber si tenim camera en el dispositiu
	//******************************************************
	private boolean teCamera(Context context) 
	{
		// Tenim camera a nivell de hardware?
		if (context.getPackageManager().hasSystemFeature(PackageManager.FEATURE_CAMERA)) 
		{
			return true;
		} 
		else 
		{
			return false;
		}
	}


	// Funcio per alliberar la gravadora multimedia
	//**************************************************
	private void alliberarGravadoraMultimedia() 
	{
		if (gravadoraMultimedia != null) 
		{
			// Fer un reset de la configuraci de la gravadora
			gravadoraMultimedia.reset();
			// Alliberar la gravadora multimedia
			gravadoraMultimedia.release();
			gravadoraMultimedia = null;
			// bloqueig de la camera per un us futur
			mCamera.lock(); 
		}
	}

	// Funcio per preparar la gravadora multimedia
	//*************************************************
	private boolean prepararGravadoraMultimedia() 
	{
		// crear la instncia del objecte gravadora multimedia
		gravadoraMultimedia = new MediaRecorder();
		
		// Desbloquejar la camera perqu un altre procs pugi utilitzar-la
		mCamera.unlock();
		
		// Associar la camera en el objecte de gravadora multimedia
		gravadoraMultimedia.setCamera(mCamera);

		// Definir quin sera el origen d'audio i de video
		gravadoraMultimedia.setAudioSource(MediaRecorder.AudioSource.CAMCORDER);
		gravadoraMultimedia.setVideoSource(MediaRecorder.VideoSource.CAMERA);
		
		// Definir el perfile de qualitat
		gravadoraMultimedia.setProfile(CamcorderProfile.get(CamcorderProfile.QUALITY_720P));
		
		// Definir on volem guardar la gravacio
		gravadoraMultimedia.setOutputFile("/sdcard/myvideo.mp4");
		
		// Temps mxim de gravacio amb milisegons
		gravadoraMultimedia.setMaxDuration(600000);
		
		// Grandaria mxima de la gravaci en bytes
		gravadoraMultimedia.setMaxFileSize(50000000);

		try 
		{
			// Prepara la gravadora
			gravadoraMultimedia.prepare();
		} 
		catch (IllegalStateException e) 
		{
			// Si hi una error alliberar la gravadora
			alliberarGravadoraMultimedia();
			return false;
		} 
		catch (IOException e) 
		{
			// Si hi ha un error allibera la gravadora
			alliberarGravadoraMultimedia();
			return false;
		}
		
		// Retornar true si tot es OK !!
		return true;

	}

	// Funcio per alliberar la camera
	//******************************************
	private void alliberarCamera() 
	{
		// Si tenim una camera associada, fer un alliberar
		// el metode s el releaze
		if (mCamera != null) 
		{
			mCamera.release();
			mCamera = null;
		}
	}

		
	//**********************************************************************
	//**********************************************************************
	// Metodes de continuar i aturar la gravaci de la gravadora multimedia
	//**********************************************************************
	//**********************************************************************
	
	// Event de la pausa de la camera
	//*************************************************
	@Override
	protected void onPause() 
	{
		super.onPause();
		alliberarCamera();
	}

	// Definir la funci per continuar la gravacio
	//*************************************************
	public void onResume() 
	{
		// Executar el metode de la classe mare
		super.onResume();
		
		// No Tenim camera?
		// Mostrar missatge i finalitzar
		if (teCamera(this) == false) 
		{
			Toast toast = Toast.makeText(this, "El teu mobil no te cap camera!", Toast.LENGTH_LONG);
			toast.show();
			finish();
		}
		
		// Si el objecte de camera esta buit, no te valor
		if (mCamera == null) 
		{
			// Si no existeix la camera frontal
			if (buscarCameraFrontal() < 0) 
			{
				Toast.makeText(this, "No tens camera frontal.", Toast.LENGTH_LONG).show();
				// Desactivar el boto de canvi de frontal i darrera
				botoCanvi.setVisibility(View.GONE);
			}
			
			// Obrir la camera del darrera
			mCamera = Camera.open(buscarCameraDarrera());
			
			// Actualitzar els objecte previes del layout
			mPreview.refrescarCamera(mCamera);
		}
	}

}

